module Variables where

import MyParser
import HXML
import DeleteEmb
import Conditions

manageVariables::[Pos]->[Var]->Tree XMLNode->([(String,String)],[([String],String)],[String])->Int->[Pos]
manageVariables [] _ _ _ 1 = []
manageVariables [] _ text _ 0 = [(1,0,0,0,0,text)]
manageVariables (pos:ps) [] text ([],[],[]) pn
	|(pn == 1) = (pre,d,b,rc,ec,newEmb):(manageVariables ps [] text ([],[],[]) pn)
	|(pn == 0) = manageVariables ps [] newText ([],[],[]) pn
	where
	(pre,d,b,rc,ec,embT) = pos
	newText = deleteEmbeddingFromText text embT []
	(newEmb,_) = buildNewEmbedd [] embT
manageVariables _ [] _ cond _ = []
manageVariables (pos:ps) vars text cond pn
	|(assLen < lcondvar) || (verifyAllAssoc condVars assocList) || (nassLen < lcondvar) || (verifyAllAssoc condVars newAssocList) = manageVariables ps vars text cond pn
	|(pn == 1) = (pre,d,b,rc,ec,newEmb):(manageVariables ps vars text cond pn)
	|(pn == 0) = manageVariables ps vars newText cond pn
	where
	(regExp,otherC,condVars) = cond
	(pre,d,b,rc,ec,embT) = pos
	(assocList,_) = findVars text pn vars embT
	(newAssocList) = orderAssoc (verifyConditions assocList (regExp,otherC))
	newText = deleteEmbeddingFromText text embT (clear newAssocList)
	(newEmb,_) = buildNewEmbedd (clear newAssocList) embT
	assLen = length assocList
	nassLen = length newAssocList
	lcondvar = length condVars

orderAssoc [] = []
orderAssoc (l:ls) = (orderAssoc [y|y<-ls, ltAss y l]) ++ (l: (orderAssoc [y|y<-ls, ltAss l y]))

ltAss (v1,n1,ts1) (v2,n2,ts2)
	|nn1 < nn2 = True
	|otherwise = False
	where
	nn1 = (read n1)::Int
	nn2 = (read n2)::Int

clear [] = []
clear (x:xs) = nx:(clear xs)
	where
	(var,n,ts)=x
	nx = (n,ts)

{-
esP = mymap viewAssoc assoc
	where
	(assoc,_)= findVars text 0 [("2","X"),("3","Y")] (Tree (ELNode "f^1^1" []) [(Tree (ELNode "b^2^2" []) []),(Tree (ELNode "a^3^4" []) [])])
	(_,_,text) = parseText "<f><b>d</b><a><f>b</f>d</a></f>"
-}
verifyAllAssoc [] _ = False
verifyAllAssoc (c:cs) assoc
	|isNotVarInAssoc c assoc = True
	|otherwise = verifyAllAssoc cs assoc

isNotVarInAssoc c [] = True
isNotVarInAssoc c (a:as)
	|varA==c = False
	|((length varA) == 2) && ((tail varA) == c) = False
	|otherwise = isNotVarInAssoc c as
	where
	(varA,_,_) = a

viewAssoc (s,list) = do{putStrLn ("assoc:\n"++s++"\n"++show (head list)++"\n");}

findVars::Tree XMLNode->Int->[Var]->Tree XMLNode->([(String,String,[Tree XMLNode])],[Var])
findVars _ _ [] _ = ([],[])
findVars text pn (v:vs) embTree = case embTree of
	(Tree (ELNode label []) args)
		|(preQ == pre) && (null associations) -> findMap (findVars text pn) vs args
		|(preQ == pre) && (pn == 1) -> let (result,vars) = findMap (findVars text pn) vs args
				  		in ((((varName var),preq,associations):result),vars)
		|(preQ == pre) && (pn == 0) -> let (result,vars) = findMap (findVars text pn) vs args
				  		in ((((varName var),preq,associationsNeg):result),vars)
		|preQ < pre -> findMap (findVars text pn) (v:vs) args
		|preQ > pre -> findVars text pn vs embTree
		where			
		associations = calcAssociations (findSons text preT) args
		associationsNeg = calcAssocForNegativeQueries (findSons text preT) args
		preq = getLabelComponent label 2
		preQ = (read preq) ::Int
		preT = read (getLabelComponent label 3) ::Int
	(Tree (TXNode label) [])
		|(preQ == pre) && (null assoc) -> ([],vs)
		|(preQ == pre) && (pn == 1) -> ([((varName var),preq,assoc)],vs)
		|(preQ == pre) && (pn == 0) -> ([((varName var),preq,assocNeg)],vs)
		|preQ < pre -> ([],(v:vs))
		|preQ > pre -> findVars text pn vs embTree
		where
		assoc = findSons text preT
		assocNeg = map addDelim assoc
		preq = getLabelComponent label 2
		preQ = (read preq) ::Int
		preT = read (getLabelComponent label 3) ::Int
	where
	(preV,var) = v
	varName::String->String
	varName (x:xs)
		|(length (x:xs))==1 = (x:xs)
		|otherwise = xs
	pre = (read preV) ::Int

findMap _ [] _ = ([],[])
findMap _ vs [] = ([],vs)
findMap f vs (t:ts) = ((result++results),vars)
	where
	(result,var) = f vs t
	(results,vars) = findMap f var ts

calcAssociations [] _ = []
calcAssociations trees [] = fst (buildMap (buildNewEmbedd) [] trees)
calcAssociations (t:ts) (b:bs)
	|preT==preQ = calcAssociations ts bs
	|preT<preQ = (fst (buildNewEmbedd [] t)):(calcAssociations ts (b:bs))
	|preT>preQ = (fst (buildNewEmbedd [] t)):(calcAssociations ts bs)
	where
	preT = read (getfromLabel t 2) ::Int
	preQ = read (getfromLabel b 3) ::Int

calcAssocForNegativeQueries [] _ = []
calcAssocForNegativeQueries trees [] = map addDelim trees
calcAssocForNegativeQueries (t:ts) (b:bs)
	|preT==preQ = calcAssociations ts bs
	|preT<preQ = (addDelim t):(calcAssociations ts (b:bs))
	|preT>preQ = (addDelim t):(calcAssociations ts bs)
	where
	preT = read (getfromLabel t 2) ::Int
	preQ = read (getfromLabel b 3) ::Int

findSons::Tree XMLNode->Int->[Tree XMLNode]
findSons (Tree (TXNode _) []) _ = []
findSons (Tree (ELNode label _) args) pre
	|preT == pre = args
	|otherwise = findSonsAux args pre
	where
	preT = read (getLabelComponent label 2) ::Int

findSonsAux [] _ = []
findSonsAux (t:[]) pre = findSons t pre
findSonsAux (t1:t2:ts) pre
	|pre<pre2 = findSons t1 pre
	|otherwise = findSonsAux (t2:ts) pre
	where
	pre2 = read (getfromLabel t2 2) ::Int

addDelim (Tree (ELNode label atts) args) = (Tree (ELNode (addS label) atts) (map addDelim args))
addDelim (Tree (TXNode label) []) = (Tree (TXNode (addS label)) [])
addS [] = []
addS (x:xs)
	|x=='^' = '^':('0':(x:xs))
	|otherwise = x:(addS xs)

buildNewEmbedd::[(String,[Tree XMLNode])]->Tree XMLNode->(Tree XMLNode,[(String,[Tree XMLNode])])
buildNewEmbedd [] tree = case tree of
	(Tree (ELNode label []) args) -> let (sons,assocList) = buildMap (buildNewEmbedd) [] args
					 in ((Tree (ELNode name []) sons),assocList)
		where
		name = getLabelComponent label 1
	(Tree (TXNode label) []) -> ((Tree (TXNode name) []),[])
		where
		name = getLabelComponent label 1

buildNewEmbedd (x:xs) tree = case tree of
	(Tree (ELNode label []) args)
		|preQ==pre -> 	let (sons,assocList) = buildMap (buildNewEmbedd) xs args
				in ((Tree (ELNode name []) (list++sons)),assocList)
		|preQ<pre -> 	let (sons,assocList) = buildMap (buildNewEmbedd) (x:xs) args
				in ((Tree (ELNode name []) sons),assocList)
		|preQ>pre ->	let (sons,assocList) = buildMap (buildNewEmbedd) xs args
				in ((Tree (ELNode name []) sons),assocList)
		where
		name = getLabelComponent label 1
		preQ = read (getLabelComponent label 2) ::Int
	(Tree (TXNode label) [])
		|preQ==pre -> ((Tree (ELNode name []) list),xs)
		|otherwise -> ((Tree (TXNode name) []),(x:xs))
		where
		name = getLabelComponent label 1
		preQ = read (getLabelComponent label 2) ::Int
	where
	(preV,list) = x
	pre = (read preV) ::Int

buildMap _ vs [] = ([],vs)
buildMap f vs (t:ts) = ((result:results),assoc)
	where
	(result,ass) = f vs t
	(results,assoc) = buildMap f ass ts

{-
es = findVars (Tree (ELNode "f,1" []) [(Tree (ELNode "g,2" []) [(Tree (TXNode "a,3") [])]),(Tree (TXNode "b,4") [])]) [("1","X")] (Tree (ELNode "f,1,1" []) [])
es2 = calcAssociations [(Tree (ELNode "g,2" []) [(Tree (TXNode "a,3") [])]),(Tree (TXNode "b,4") [])] [(Tree (TXNode "b,2,4") [])]

es3 = mymap viewPos list
	where
	(index,map,tree) = parseText "<f><b>d</b><a><f>b</f>d</a></f>"
	list = manageVariables [(6,0,6,0,0,(Tree (TXNode "b,1,6") []))] [("1","X")] tree
es4 = findSons tree "6"
	where
	(index,map,tree) = parseText "<f><b>d</b><a><f>b</f>d</a></f>"

returnEmbeddings::[([Pos],[Var])]->Tree XMLNode->Int->[[Pos]]
returnEmbeddings [] _ _ = []
returnEmbeddings (x:xs) text pn = (manageVariables posList vars text pn):(returnEmbeddings xs text pn)
	where
	(posList,vars) = x
-}